#5 modifications:
#1. blue snake
#2. custom snake head
#3. custom font: sans
#4. snake starts at 5 length
#5. custom apple


import pygame
import time
import random
import math

pygame.init()

white = (255,255,255)
black = (0,0,0)
red = (255,0,0)
green = (0,155,0)
snakeBlue = (63,72,204)

display_width = 800
display_height = 600

gameDisplay = pygame.display.set_mode((display_width, display_height))
pygame.display.set_caption('Slither')

img = pygame.image.load('snakeHead.png')
appleImg = pygame.image.load('apple.png')
bodyImg = pygame.image.load('snakeBody.png')

clock = pygame.time.Clock()

block_size = 20
FPS = 15

direction =  "right"

smallFont = pygame.font.SysFont("sans", 25) #sans
medFont = pygame.font.SysFont("sans", 50)   #sans
largeFont = pygame.font.SysFont("sans", 80) #sans

def game_intro():

    intro = True

    while intro:

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()

            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_c:
                    intro = False
                if event.key == pygame.K_q:
                    pygame.quit()
                    quit()



                
        gameDisplay.fill(black)
        message_to_screen("Welcome to Slither",
                          snakeBlue,
                          -100,
                          "large")
        message_to_screen("The objective of the game is to eat red apples",
                          white,
                          -30)
        message_to_screen("The more apples you eat, the longer you get",
                          white,
                          10)
        message_to_screen("If you run into yourself, or the edges, you die!",
                          white,
                          50)
        message_to_screen("Press C to play or Q to quit.",
                          white,
                          180)
        
        pygame.display.update()
        clock.tick(15)


def snake(block_size, snakeList):

    if direction == "right":
        head = pygame.transform.rotate(img, 270)

    if direction == "left":
        head = pygame.transform.rotate(img, 90)

    if direction == "up":
        head = img

    if direction == "down":
        head = pygame.transform.rotate(img, 180)

    gameDisplay.blit(head, (snakeList[-1][0], snakeList[-1][1]))
    
    for XnY in snakeList[:-1]:
        pygame.draw.rect(gameDisplay, snakeBlue, [XnY[0],XnY[1],block_size,block_size])
        gameDisplay.blit(bodyImg, [XnY[0],XnY[1],block_size,block_size])

def text_objects(text,color, size):
    if size == "small":
        textSurface = smallFont.render(text, True, color)
    elif size == "medium":
        textSurface = medFont.render(text, True, color)
    elif size == "large":
        textSurface = largeFont.render(text, True, color)

    return textSurface, textSurface.get_rect()

def message_to_screen(msg,color, y_displace=0, size = "small"):
    textSurf, textRect = text_objects(msg,color,size)
    textRect.center = (display_width / 2), (display_height / 2)+y_displace
    gameDisplay.blit(textSurf, textRect)

def gameLoop():
    global direction
    gameExit = False
    gameOver = False
    lead_x = display_width/2
    lead_y = display_height/2
    
    lead_x_change = 10
    lead_y_change = 0

    snakeList = []
    snakeLength = 5

    randAppleX = round(random.randrange(0, display_width-block_size))#/10.0)*10.0
    randAppleY = round(random.randrange(0, display_height-block_size))#/10.0)*10.0
    
    while not gameExit:

        while gameOver == True:
            gameDisplay.fill(black)
            message_to_screen("Game Over",
                              red,
                              y_displace=-50,
                              size="large")
            
            message_to_screen("Press C to play again or Q to quit",
                              black,
                              50)
            pygame.display.update()

            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    gameExit = True
                    gameOver = False
                if event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_q:
                        gameExit = True
                        gameOver = False
                    if event.key == pygame.K_c:
                        gameLoop()
        

        for event in pygame.event.get():


            
            if event.type == pygame.QUIT:
                gameExit = True
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_LEFT and direction != "right":
                    direction = "left"
                    lead_x_change = -block_size
                    lead_y_change = 0
                elif event.key == pygame.K_RIGHT and direction != "left":
                    direction = "right"
                    lead_x_change = block_size
                    lead_y_change = 0
                elif event.key == pygame.K_UP and direction != "down":
                    direction = "up"
                    lead_y_change = -block_size
                    lead_x_change = 0
                elif event.key == pygame.K_DOWN and direction != "up":
                    direction = "down"
                    lead_y_change = block_size
                    lead_x_change = 0

        if lead_x >= display_width or lead_x < 0 or lead_y >= display_height or lead_y < 0:
            gameOver = True
       

        lead_x += lead_x_change
        lead_y += lead_y_change

        gameDisplay.fill(black)

        #appleThickness = 30
        #pygame.draw.rect(gameDisplay, red, [randAppleX, randAppleY, appleThickness, appleThickness])
        gameDisplay.blit(appleImg, [randAppleX, randAppleY])

        snakeHead = []
        snakeHead.append(lead_x)
        snakeHead.append(lead_y)
        snakeList.append(snakeHead)

        if len(snakeList) > snakeLength:
            del snakeList[0]

        for eachSegment in snakeList[:-1]:
            if eachSegment == snakeHead:
                gameOver = True
        
        snake(block_size, snakeList)

        pygame.display.update()

            
##        if lead_x >= randAppleX and lead_x <= randAppleX + appleThickness:
##            if lead_y >= randAppleY and lead_y <= randAppleY + appleThickness:
##                randAppleX = round(random.randrange(0, display_width-block_size))#/10.0)*10.0
##                randAppleY = round(random.randrange(0, display_height-block_size))#/10.0)*10.0
##                snakeLength += 1

        if lead_x > randAppleX and lead_x < randAppleX + 30 or lead_x + block_size > randAppleX and lead_x + block_size < randAppleX + 30:
            if lead_y > randAppleY and lead_y < randAppleY + 30 or lead_y + block_size > randAppleY and lead_y + block_size < randAppleY + 30:
                randAppleX = round(random.randrange(0, display_width-block_size))#/10.0)*10.0
                randAppleY = round(random.randrange(0, display_height-block_size))#/10.0)*10.0
                snakeLength += 1
            elif lead_y + block_size > randAppleY and lead_y + block_size < randAppleY + 30:
                randAppleX = round(random.randrange(0, display_width-block_size))#/10.0)*10.0
                randAppleY = round(random.randrange(0, display_height-block_size))#/10.0)*10.0
                snakeLength += 1

        clock.tick(FPS)


    pygame.quit()
    quit()

game_intro()

gameLoop()
